import javax.swing.filechooser.FileFilter;
import java.io.File;

/**
 * This class is used when listing files on a open/save window for png
 * files.
 *
 * @author Alberto M. B. Simes
 */
public class PngFilter extends FileFilter {

    /**
     * This method will be called for each file or directory inside
     * the current listing directory. It should return a true value
     * whenever the file should be shown.
     *
     * @param file The file object to be analyzed
     * @return A boolean if the file is a directory or has the .png
     *         extension
     */
    public boolean accept(File file) {
	if (file.isDirectory()) {
	    return true;
	} else {
	    String filename = file.toString();
	    return filename.endsWith(new String(".png"));
	}
    }

    /**
     * Used by the listing file window to identify the current file
     * filter
     *
     * @return A string with the filter description
     */
    public String getDescription() {
	return new String("PNG Files (*.png)");
    }
    
}
